#ifndef __CAN_H_
#define __CAN_H_


#define 	DELAY_SEL_ADC	5						// Nombre de cycles ncessaire pour la conversion ADC	

#define		TRIS_JOY_Y		TRISEbits.TRISE0		// Direction du port de joystick (Y)
#define		TRIS_JOY_X		TRISAbits.TRISA5		// Direction du port de joystick (X)
#define		TRIS_BAT_18V	TRISAbits.TRISA3		// Direction du port de mesure de la batterie 18.5V
#define		TRIS_BAT_12V	TRISAbits.TRISA2		// Direction du port de mesure de la batterie 12V
#define		TRIS_TEL_30		TRISAbits.TRISA1		// Direction du port du tlmtre 30cm
#define		TRIS_TEL_150	TRISAbits.TRISA0		// Direction du port du tlmtre 150cm


// --------------------------------------------------------------------------
/* Fonction CAN_Init
 * Initialise les convertisseurs Analogiques/Numriques (et les ports lis)
*/
void CAN_Init(void);



// --------------------------------------------------------------------------
/* Fonction CAN_Convert
 * Effectue une conversion sur le canal pass en paramtre
 * La valeur retourne est le rsultat brut de la converion
 * appartenant  l'intervalle [0;1023]
*/
int CAN_Convert(unsigned char);


#endif