// Fichier Distributeur.h 
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                En-tte de la librairie           	*
 *					Distributeru						*
 *                                                      *
 * .Date de cration : 09/05/07                         *
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour les distributeur 		*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/
#ifndef __DISTRIBUTEUR_H__
#define __DISTRIBUTEUR_H__

#define		Y_DISTRI_BLANC			750				// Position en Y du barillet blanc

#include "lcd.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "rouleaux.h"
#include "barillet.h"
//#include "strategie_bleu.h"
#include "Telemetres.h"
#include "canon.h"
#include "Tourelle.h"



extern volatile char		Nb_Balles_Distributeur_Blanc_Rouge;						// Nombre de balles dans le distributeur blanc du ct bleu
extern volatile char		Nb_Balles_Distributeur_Bleu;								// Nombre de balles dans le distributeur bleu
extern volatile char		Nb_Balles_Distributeur_Rouge;								// Nombre de balles dans le distributeur rouge
extern volatile char		Nb_Balles_Distributeur_Blanc_Bleu;						// Nombre de balles dans le distributeur blanc du ct rouge



// --------------------------------------------------------------------------
/* Routine qui va cherche N balles au distributeur bleu
 * Le robot doit absoluement se trouver juste en face du distributeur
 *
 * Arguments : 
 * 	Le nombre de balles bleues dsir dans le barillet
 *  Le nombre d'essai supplmentaire  faire en plus du nombre de balles
 * 
 * Paramtre retourn : 
 *  aucun


void Distributeur_Bleu (char NbBalles, char NbEssaisSup);
*/


// --------------------------------------------------------------------------
/* Routine qui va cherche N balles au distributeur bleu
 * Le robot doit absoluement se trouver juste en face du distributeur
 *
 * Arguments : 
 * 	Le nombre de balles bleues dsir dans le barillet
 *  Le nombre d'essai supplmentaire  faire en plus du nombre de balles
 * 
 * Paramtre retourn : 
 *  aucun
*/

void Distributeur_Rouge (char NbBalles, char NbEssaisSup);



// --------------------------------------------------------------------------
/* Routine qui va cherche N balles au distributeur blanc du ct bleu
 * Le robot doit absoluement se trouver juste en face du distributeur
 *
 * Arguments : 
 * 	Le nombre de balles blanches dsir dans le robot
 *  Le nombre d'essai supplmentaire  faire en plus du nombre de balles
 * 
 * Paramtre retourn : 
 *  aucun
*/

void Distributeur_Blanc_Bleu (char NbBalles, char NbEssaisSup);



// --------------------------------------------------------------------------
/* Routine qui va cherche N balles au distributeur blanc du ct rouge
 * Le robot doit absoluement se trouver juste en face du distributeur
 *
 * Arguments : 
 * 	Le nombre de balles blanches dsir dans le robot
 *  Le nombre d'essai supplmentaire  faire en plus du nombre de balles
 * 
 * Paramtre retourn : 
 *  aucun
*/

void Distributeur_Blanc_Rouge (char NbBalles, char NbEssaisSup);



// --------------------------------------------------------------------------
/* Routine fait le complment de balles
 *
 * Arguments : 
 * 	bleue : Nombre de balles bleues qu'on veut dans le barillet
 *  blanche : Nombre de balles blanches qu'on veut dans le barillet
 * 
 * Paramtre retourn : 
 *  aucun
*/
char Complement_Rouge(char rouge,char blanche, char recal);


#endif
