// Fichier Propulsion.H
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Code source de la librairie           *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/


#include <delays.h>




// --------------------------------------------------------------------------
/* Recale le robot en marche arrre aux switchs
 * Arguments : 
 *  Vitesse du robot grossire pour l'approche
 *  Delay pendant lequel on force sur le bord
 *
 * Paramtre renvoy : 
 *   0 : Tout va bien
 * 	-1 : un problme est survenu pendant l'envoi d'un commande
*/
int Recalage_Switch(int Vit, int Delay)
{
	
	while (!IO_Sw_Gauche() || !IO_Sw_Droit())						// Tant que les deux switchs ne sont pas activs
	{
		switch (IO_Sw_Gauche()+2*IO_Sw_Droit())
		{
			case 0x00:	if (Direct_Propulsion (-Vit, -Vit)) return -1;	break;	// Si on a aucun des switchs, on recule tout droit
			case 0x01:	if (Direct_Propulsion (0, -Vit)) return -1;	break;		// Si on a le gauche, on recule  droite
			case 0x02:	if (Direct_Propulsion (-Vit, 0)) return -1; break;		// Si on a le droit , on recule  gauche
		}			
	}
	if (Delay!=0)
	{
		if (Direct_Propulsion (-Vit, -Vit)) return -1;				// Un p'tit coup pour conclure
		Delay10KTCYx(Delay);										// Pendant un bref instant
	}
	if (Stop_Propulsion()) return -1;								// On arrte et on quitte
	return 0;
}




