// Fichier IO.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Entte de la librairie                *
 *					des entres/sorties 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - Prototype des fonctions pour 					*
 *			la carte principale   						*
 *                                                      *
 * .Grandes modifications :                             *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#define 	JACK			PORTBbits.RB0		// Jack
#define		SWITCH_GAUCHE	PORTBbits.RB1 		// Switch gauche
#define 	SWITCH_DROIT	PORTBbits.RB2		// Switch droit


#define 	TRIS_JACK			TRISBbits.TRISB0		// Direction du jack
#define		TRIS_SWITCH_GAUCHE	TRISBbits.TRISB1 		// Direction du switch gauche
#define 	TRIS_SWITCH_DROIT	TRISBbits.TRISB2		// Direction du switch droit



// --------------------------------------------------------------------------
/* Initialise les ports des entres numriques (Jack, switchs de recalage)
 *  Pas de paramtre
*/
void IO_Init (void);



// --------------------------------------------------------------------------
/*	Retourne l'tat du Jack
 *  0 = pas de jack
 *  1 = jack enfon
*/
unsigned char IO_Jack (void);




// --------------------------------------------------------------------------
/*	Retourne l'tat du switch gauche
 *  0 = switch au repos
 *  1 = switch enfon
*/
unsigned char IO_Sw_Gauche (void);





// --------------------------------------------------------------------------
/*	Retourne l'tat du switch droit
 *  0 = switch au repos
 *  1 = switch enfon
*/
unsigned char IO_Sw_Droit (void);



