#include <adc.h>
#include <delays.h>
#include <p18f452.h>

#include "CAN.h"
#include "Joystick.h"





// --------------------------------------------------------------------------
/* Fonction Joy_X
 * Retourne la position du Joystick en X
 * Valeur comprise entre 0 et 1023
 *  0    : Joystick  gauche
 *  1023 : Joystick  droite
*/
int Joy_X()
{
	return (0x3FF-CAN_Convert(ADC_CH4)); 	// Retourne le rsultat mis en forme
}	




// --------------------------------------------------------------------------
/* Fonction Joy_Y
 * Retourne la position du Joystick en Y
 * Valeur comprise entre 0 et 1023
 *  0    : Joystick en bas
 *  1023 : Joystick en haut
*/
int Joy_Y()
{
	return (CAN_Convert(ADC_CH5)); 			// Retourne le rsultat mis en forme
}	





// --------------------------------------------------------------------------
/* Retourne l'tat du bouton du JoyStick
 * 	0= repos
 *	1= appuy
*/
int Joy_Sw(void)
{
	return (!JOY_SWITCH);
}


// --------------------------------------------------------------------------
/* Attends un click sur le bouton du joystick
 * Plus prcisment un front montant , soir la squence :
 * 	Bouton relach
 *	Puis bouton appuy
*/
void Joy_Click(void)
{
	while (Joy_Sw());						// Attends que le bouton soit relach
	Delay100TCYx(DELAY_ANTI_REBONDS);		// Tempo pour viter les rebonds
	while (!Joy_Sw());						// Attends un appui
	Delay100TCYx(DELAY_ANTI_REBONDS);		// Tempo pour viter les rebonds
}