// Fichier MainBoard.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                 Header de la librairie               *
 *					du joystick 		 				*
 *                                                      *
 * .Date de cration : 20/01/08                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 * .Grandes modifications :                             *
 *  __________________________________________________  *
 * |   DATE   |   Auteur   |          Detail          | *
 * |--------------------------------------------------| *
 * | 28/12/07 | P.Lucidarme| Cration et code des     | *
 * |          |			   | fonctions: 			  | *
 * |          |            | - Joy_X				  | *
 * |          |            | - Joy_Y                  | *
 * |          |            | - Joy_Sw                 | * 
 * |          |            |                          | *  
 * |--------------------------------------------------| *
 * |          |            |                          | *
 * |--------------------------------------------------| *
 * |          |            |                          | *
 * |--------------------------------------------------| *
 * |__________|____________|__________________________| *
 *                                                      *
 *                                                      *
 * .Remarques :       									*
 *                                                      *                                  *
 * ATTENTION : Les convertisseurs Analogiques/Numriques*
 * doivent avoir t configurs							*
 *                                                      *
 ********************************************************/

#ifndef __JOYSTICK_H_
#define __JOYSTICK_H_


#define		JOY_SWITCH			PORTBbits.RB5			// Bouton du joystick
#define 	DELAY_ANTI_REBONDS	100						// Delai ncessaire pour viter les rebonds sur le bouton (estim  100  20MHz)


// --------------------------------------------------------------------------
/* Fonction Joy_X
 * Retourne la position du Joystick en X
 * Valeur comprise entre 0 et 1023
 *  0    : Joystick  gauche
 *  1023 : Joystick  droite
*/
int Joy_X(void);




// --------------------------------------------------------------------------
/* Fonction Joy_Y
 * Retourne la position du Joystick en Y
 * Valeur comprise entre 0 et 1023
 *  0    : Joystick en bas
 *  1023 : Joystick en haut
*/
int Joy_Y(void);




// --------------------------------------------------------------------------
/* Fonction Joy_Sw
 * Retourne l'tat du bouton du JoyStick
 * 	0= repos
 *	1= appuy
 * ...
*/
int Joy_Sw(void);




// --------------------------------------------------------------------------
/* Attends un click sur le bouton du joystick
 * Plus prcisment un front montant , soit la squence :
 * 	Bouton relach
 *	Puis bouton appuy
 *  Les ventuels rebonds sont limins par la fonction
*/
void Joy_Click(void);



#endif