// Fichier MainBoard.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                 Header de la librairie               *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 * .Grandes modifications :                             *
 *  __________________________________________________  *
 * |   DATE   |   Auteur   |          Detail          | *
 * |--------------------------------------------------| *
 * | 28/12/07 | P.Lucidarme| Cration et code des     | *
 * |          |			   | fonctions: 			  | *
 * |          |            | - ConfigureProcesseur    | *
 * |          |            | - Joy_X                  | *
 * |          |            | - Joy_Y                  | * 
 * |          |            |                          | *  
 * |--------------------------------------------------| *
 * |          |            |                          | *
 * |--------------------------------------------------| *
 * |          |            |                          | *
 * |--------------------------------------------------| *
 * |__________|____________|__________________________| *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/




// --------------------------------------------------------------------------
/* Fonction ConfigureProcesseur
 * Configure les ports en entres/sorties
 * Configure les convertisseur analogique/numrique
 * ...
*/
void ConfigureProcesseur (void);





// --------------------------------------------------------------------------
/* Fonction Joy_X
 * Retourne la position du Joystick en X
 * Valeur comprise entre 0 et 1023
 * ...
*/
int Joy_X(void);




// --------------------------------------------------------------------------
/* Fonction Joy_Y
 * Retourne la position du Joystick en Y
 * Valeur comprise entre 0 et 1023
 * ...
*/
int Joy_Y(void);




// --------------------------------------------------------------------------
/* Fonction Joy_Sw
 * Retourne l'tat du bouton du JoyStick
 * 	0= repos
 *	1= appuy
 * ...
*/
int Joy_Sw(void);
