// Fichier Recal.h 
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                En-tte de la librairie           	*
 *						Recal							*
 *                                                      *
 * .Date de cration : 09/05/07                         *
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour les recallages 		*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/
#ifndef __RECAL_H__
#define __RECAL_H__







// --------------------------------------------------------------------------
/* Recalage ct bleue
 * Le robot se place sur son aire de dpart et se recalle en X puis en Y 
 * On suppose que le robot se trouve approximativement en 2650,350 
 * Arguments : 
 *  En_X pour se recaler en X
 *	En_Y pour se recaler en Y
 * 
 * Paramtre retourn : 
 *   Aucun
*/
void Recal_Cote_Bleu (unsigned char En_X,unsigned char En_Y);



// --------------------------------------------------------------------------
/* Recalage ct rouge
 * Le robot se place sur son aire de dpart et se recalle en X puis en Y 
 * On suppose que le robot se trouve approximativement en 350,350 
 * Arguments : 
 *  En_X pour se recaler en X
 *	En_Y pour se recaler en Y
 * 
 * Paramtre retourn : 
 *   Aucun
*/
void Recal_Cote_Rouge (unsigned char En_X,unsigned char En_Y);



//-----------------------------------------------------------------------
/* Le robot se recal sur un bord avec les switchs
 * Le robot doit tre prs d'un bord
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *  0 : le recallage est un chec
 *  1 : le recallage est russit
*/
unsigned char Recal_Avant(void);



//-----------------------------------------------------------------------
/* Le robot se recal sur un bord avec les switchs
 * Le robot doit tre prs d'un bord
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *  0 : le recallage est un chec
 *  1 : le recallage est russit
*/
unsigned char Recal_Arriere(void);



#endif