#include <p18f452.h>
#include <delays.h>
#include <stdio.h>
#include <usart.h>
#include <math.h>
#include <string.h>


//#define 	JACK_DEBUG

#define		PI				3.141592653589793	// Constante Pi

#include "lcd.h"
#include "StartUp.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "rouleaux.h"
#include "IO.h"
#include "I2C_Master.h"
#include "barillet.h"
#include "HighLevel.c"
#include "Horloge.h"
#include "strategie.h"
#include "led.h"


void main()
{
	int MG,MD;
	int i;
	unsigned char Trame[8];
	int StatePropulsion,X,Y,A;
	int State=0;
	char ret;
	TEtatBarillet barillet;
	
	stdout = _H_USER;							// Passe l'affichage sur l'cran LCD
	Init_Peripheriques();						// Dmarre le robot et lance le CheckUp
	Check_Up();									// Scanne l'ensemble des priphriques et vrifie leur fonctionnement	

	
	// Attends la prsence du Jack
		
#ifndef JACK_DEBUG	
	printf ("Attente jack    ");					// Attends que le jack soit enfil
	while (!IO_Jack()); 							// Tant que le jack n'est pas prsent
	printf ("[OK]");								// Pas d'erreur
	while (IO_Jack());								// On attends le retrait du Jack
#else
	printf ("Attente Click   ");
	Joy_Click();
	printf ("[OK]");								// Pas d'erreur
#endif
	StartHorloge();									// Dmarre le chrono sur 90s

/*
	// test etat barillet
	while(1){
		ret = Etat_Barillet( &barillet );
		printf( "[%d %d %d %d %d] %d %d (r%d)\n", 
			barillet.slot[0],
			barillet.slot[1],
			barillet.slot[2],
			barillet.slot[3],
			barillet.slot[4],
			barillet.avale,
			barillet.busy,
			ret );
		Delay10KTCYx(255);
		Delay10KTCYx(255);
	}
*/
	
	
	// Va attrapper la premre balle
	
	Force_Propulsion(2910, 165, 2822);
	Commande_Rouleaux(90,90);
	
	GotoXY_Propulsion(2250, 370, 450);
	ret = AttendreFinCons_Propulsion();
	
	
	
	
	// Recule pour venir au distributeur
	
	GotoXY_Propulsion(2360, 370, -200);
	while (Etat_Propulsion ()!='a');
	/***** 1re balle bleue *****/
	
	Angle_Propulsion (-PI/2);
	while (Etat_Propulsion ()!='a');
	
	// avancer au distributeur vertical
	Direct_Propulsion(250, 250);

	
	LedRouge (0);
	while (!EstArrete());
	LedRouge (1);
	/***** distributeur vertical bleu *****/

	// reculer
	Info_Propulsion (&StatePropulsion, &X, &Y, &A);
	GotoXY_Propulsion(X, 750, -200);
	while (Etat_Propulsion ()!='a');
	
	// tourner 
	Angle_Propulsion (0);
	while (Etat_Propulsion ()!='a');
	
	for(i=0; i<2; i++) //Pour prendre deux balles blanches
	{
		// avancer
		GotoXY_Propulsion(3000, 750, 200);
						
		LedRouge (0);
		while (!EstArrete()) ;
		LedRouge (1);
		
		/***** distributeur vertical blanc *****/		
		
		// reculer pour prendre les balles
		Info_Propulsion (&StatePropulsion, &X, &Y, &A);
		GotoXY_Propulsion(X-100, Y, -200);
		while (Etat_Propulsion ()!='a');
	}
	//Pour tre sur de bien avoir pris la dernire balle
//	Delay10KTCYx(255);
//	Delay10KTCYx(255);
	
//	Commande_Rouleaux(-90,-90);	// faire tourner les rouleaux a l'envers
	
	// reculer en courbe
	GotoXY_Propulsion(750, 1400, -500);	
	while (Etat_Propulsion ()!='a');
	
	// tourner
	Angle_Propulsion (-PI/2);			
	while (Etat_Propulsion ()!='a');
		
	// reculer vite jusqu' 6 cm du bord
	Info_Propulsion (&StatePropulsion, &X, &Y, &A);
	GotoXY_Propulsion(X, 2100, -250);

	// attendre qu'un switch soit enfonc	
	while( !IO_Sw_Gauche() && !IO_Sw_Droit() );
	
	// Feinte du canard
	if( IO_Sw_Gauche() ){
		Direct_Propulsion( 0, -250 );
		while( !IO_Sw_Droit() );
	}else{
		Direct_Propulsion( -250, 0 );
		while( !IO_Sw_Gauche() );
	}
	
	//Arrt des moteurs pour jection des balles
	Stop_Propulsion ();
	
	// RECALIBRER en Y
	Info_Propulsion (&StatePropulsion, &X, &Y, &A);
	Force_Propulsion (X , 2059, -1000*PI/2);
	
	//Ejection
	Commande_Rouleaux(0, 0);
	
	State = DeposeBalle_Barillet(BLANCHE);
	printf("state=%d\n", State );
	State = DeposeBalle_Barillet(BLEUE);
	printf("state=%d\n", State );
	State = DeposeBalle_Barillet(BLANCHE);
	printf("state=%d\n", State );
	State = DeposeBalle_Barillet(BLEUE);
	printf("state=%d\n", State );
	State = DeposeBalle_Barillet(BLANCHE);
	printf("state=%d\n", State );
	
	Joy_Click();
	
	// Avance de 15cm 
	Info_Propulsion (&StatePropulsion, &X, &Y, &A);
	GotoXY_Propulsion( X, Y-150, 300);
	ret = AttendreFinCons_Propulsion();
	
	//et fait un 1/4 de tour
	Angle_Propulsion(0);
	while (Etat_Propulsion ()!='a');
	printf("Je vais reculer\n");
	
	// Reculer
	Info_Propulsion (&StatePropulsion, &X, &Y, &A);
	GotoXY_Propulsion( 0, Y, -250);	

	// attendre qu'un switch soit enfonc	
	while( !IO_Sw_Gauche() && !IO_Sw_Droit() );
	
	
	// Feinte du canard
	if( IO_Sw_Gauche() ){
		Direct_Propulsion( 0, -250 );
		while( !IO_Sw_Droit() );
	}else{
		Direct_Propulsion( -250, 0 );
		while( !IO_Sw_Gauche() );
	}
	
	Stop_Propulsion ();
	
	Info_Propulsion (&StatePropulsion, &X, &Y, &A);
	printf("[X: %d], [A: %d], [A: %d]\n", X, Y, A);
	
	while(!Joy_Sw());
	
	GotoXY_Propulsion(2550, 750, 300);
	while ( Etat_Propulsion ()!='a');
	
	Angle_Propulsion (0);
	while (Etat_Propulsion ()!='a');
	
	
	for(i=0; i<2; i++) //Pour prendre deux balles blanches
	{
		// avancer
		Direct_Propulsion(200,200);
				
		LedRouge (0);
		while (!EstArrete()) ;
		LedRouge (1);
		
		/***** distributeur vertical blanc *****/		
		
		// reculer pour prendre les balles
		Info_Propulsion (&StatePropulsion, &X, &Y, &A);
		GotoXY_Propulsion(X-100, Y, -200);
		while (Etat_Propulsion ()!='a');
		if(i==1)
		{
			Angle_Propulsion (0);
			while (Etat_Propulsion ()!='a');
		}
	}
	
	Info_Propulsion (&StatePropulsion, &X, &Y, &A);
	GotoXY_Propulsion(X-200, Y, -200);
	while (Etat_Propulsion ()!='a');
	
	Angle_Propulsion (-PI/2);
	while (Etat_Propulsion ()!='a');
	Angle_Propulsion (PI);
	while (Etat_Propulsion ()!='a');
	Angle_Propulsion (PI/2);
	while (Etat_Propulsion ()!='a');
	Angle_Propulsion (0);
	while (Etat_Propulsion ()!='a');
	
	Stop_Propulsion ();
	
	while (1);





	
/*	
	Force_Propulsion (0,0,0);						// Force la position du robot en 0,0,0
	Commande_Rouleau_Droit(50);
	Commande_Rouleau_Gauche(-50);
	
	GotoXY_Propulsion (500, -10, 300);				
	while (Etat_Propulsion ()!='a');	
	
	Angle_Propulsion(PI/2);
	while (Etat_Propulsion ()!='a');
*/	

	LCD_Clear();
	GotoXY_Propulsion (-200, 100, -200);				
	while (Etat_Propulsion ()!='a')
	{			
		State=Info_Propulsion (&StatePropulsion,&X,&Y,&A);
		LCD_GotoXY (0,0);
		if (State==0)
			printf ("%c %5d %5d %5d\n",StatePropulsion,X,Y,A);			
		else
			printf ("Err Lecture Etat   \n");
	}
	
	/*** C'est parti ! ***/
	LCD_Clear();
	while(1)
	{	
		
		State=Info_Propulsion (&StatePropulsion,&X,&Y,&A);
		LCD_GotoXY (0,0);
		if (State==0)
			printf ("%c %5d %5d %5d\n",StatePropulsion,X,Y,A);			
		else
			printf ("Err Lecture Etat   \n");

	
		if(!Joy_Sw())
		{
			MG = (Joy_Y()-512) + ( Joy_X() -512 );
			MD = (Joy_Y()-512) - ( Joy_X() -512 );
			LCD_GotoXY (0,1);
			if (Direct_Propulsion(MG,MD)) 
				printf ("Err Direct");
			else
				printf ("          ");
		}
		else
		{
			Delay10KTCYx(255);
			Delay10KTCYx(255);
			Delay10KTCYx(255);
			
			LCD_GotoXY (0,2);
			if (Angle_Propulsion(PI/2)) 
				printf ("Err Angle");
			else
				printf ("         ");
		
			do
			{
				State=Info_Propulsion (&StatePropulsion,&X,&Y,&A);
				LCD_GotoXY (0,0);
				if (State==0)
					printf ("%c %5d %5d %5d\n",StatePropulsion,X,Y,A);			
				else
					printf ("Err Lecture Etat   \n");
			}
			while (StatePropulsion!='a');
		}
		
	}		

}
