#include <p18f452.h>
#include <delays.h>
#include <stdio.h>
#include <usart.h>
#include <math.h>




#include "LCD.h"
#include "Joystick.h"
#include "CAN.h"
#include "Batteries.h"
#include "IO.h"
#include "Telemetres.h"
#include "serial.h"
#include "I2C_Master.h"
#include "led.h"
#include "menu.h"
#include "robot.h"

TElementListe liste[9] = {
	{0, "ligne0 Stphanie"},
	{1, "ligne1 Sophie"},
	{2, "ligne2 Amlie"},
	{3, "ligne3 Georgette"},
	{4, "ligne4 Zo"},
	{5, "ligne5 Annie"},
	{6, "ligne6 Claire"},
	{7, "ligne7 Magalie"},
	{-1, ""}
};


void main()
{
	int x=0;
	char ch=0;
	int Val1=0;
	int Val2=0;
	unsigned int cpt=0;
	
	int Value=0;
	
	int i=0;
	int ack=0;
	unsigned char Data[2]={0x00,30},DataReceive[10]={1,2,3,4};
	
	
	//ConfigureProcesseur();

	Led_Init();		// Initalisation de la led et des switchs
	LCD_Init();		// Afficheur LCD
	CAN_Init();		// Convertisseurs Analogiques/Numriques
	IO_Init();		// Initialisation des ports pour les switchs et le jack
	Serial_Init();	// Initialisation de la liaison srie
	I2C_Init();		// Initialisation du bus I2C


	stdout = _H_USER;							// Flux de sortie = afficheur LCD
	LCD_BackLight(LCD_BL_ON);					// Allume le rtro-clairage
	LCD_CURSOR	(LCD_CURSOR_OFF);				// Eteind le curseur
	
	
	
	
	
	
	Value=5;
	while (1)
	{	
				
		i++;
		//printf ("%d\n",i);
		if (i==10000) 
		{
			if (Commande_Rouleau_Droit(0))
			{
				printf ("0-Tr %d ",0);
				printf ("Error");
				while (1);
			}
			Value=-Value;
			
			printf ("%u0e3 *-* Vit=%d\n",++cpt,ack);
			Delay10KTCYx(Joy_Y()-Joy_X()+ack);			
			i=0;
		}
		
		if (Commande_Rouleau_Droit(Value))
		{
			printf ("Tr %d ",Value);
			printf ("Error");
			while (1);
		}
		ack=Mesure_Rouleau_Droit();
		if (ack==0x0FFF)
		{
			printf ("Re %d\n",ack);
			printf ("Error");
			while (1);
		}

		//Delay100TCYx(10);
		LED_ROUGE=!LED_ROUGE;
	}




	while(1)
	{
		
		Value=SaisirEntier (0,0,-128,127,Value);
	
		if (Commande_Rouleau_Droit(Value++))
		{
			printf ("Error");
		}
		Delay10KTCYx(100);
		LED_ROUGE=!LED_ROUGE;

		printf ("Tr:%d  ",Value);
		while (Joy_Sw());
		Delay100TCYx(10);
		while (!Joy_Sw())
		{
			Delay10KTCYx(2);
			printf ("\n%d   ",Mesure_Rouleau_Droit());
		}
		Delay100TCYx(10);
		while (Joy_Sw());
		Delay100TCYx(10);
		LCD_Clear();
	}

	while(1)
	{
		ChoisirDansListe( liste );
	}

	while (1)
	{

		stdout = _H_USER;							// Flux de sortie = afficheur LCD

		LedRouge (1);
		
		Delay10KTCYx(10);
		LedRouge (0);
		
		Delay10KTCYx(10);		
		LCD_GotoXY (0,0);
		printf ("X=%d   \n",Joy_X());
		printf ("Y=%d   \n",Joy_Y());
		printf ("Sw=%d   \n",Joy_Sw());
		LCD_GotoXY (10,0);
		printf ("12V=%d",(int)floor(BatterieLogiqueVolt()*100));
		LCD_GotoXY (10,1);
		printf ("18V=%d",(int)floor(BatteriePuissanceVolt()*100));
		LCD_GotoXY (6,2);
		printf ("30=%d  ",Telemetre30cm());
		LCD_GotoXY (13,2);
		printf ("150=%d  ",Telemetre150cm());
		LCD_GotoXY (0,3);
		printf ("%d    %d %d  ",IO_Jack(),IO_Sw_Gauche(),IO_Sw_Droit() );
		
		stdout = _H_USART;							// Flux de sortie = afficheur LCD

//		printf ("%d\n",I2C_Send(0x40,i++));
	}

	
	stdout = _H_USER;							// Flux de sortie = afficheur LCD

	LCD_BackLight (LCD_BL_ON);
	LCD_CURSOR(LCD_CURSOR_BLINK);
	
	while (1)
	{
		Val1=(Joy_X()-512)/4;
//		ack=I2C_Send(0xBE, Val1);
		printf ("%x -> ACK : %d\n",Val1,ack);
		Delay10KTCYx(10);

		Val2=(Joy_Y()-512)/4;
		//ack=I2C_Send(0x4E, Val2);
		printf ("%x -> ACK : %d\n",Val2,ack);
		Delay10KTCYx(10);

	}

	while (ch!=27)								// Boucle infinie
	{	
/*
		if (DataRdyUSART())						// Attends la prsence d'un caractre sur la liaison srie
		{
			ch=ReadUSART();						// Lit le caractre
			printf ("%c",ch);			
			if ((ch>=97) && (ch<=122)) ch-=32;	// Convertie le caractre en minuscule si c'est une lettre minuscule
			WriteUSART(ch);						// Renvoie le caractre aprs traitement
		}

			RedLed=1;
			ack=I2C_Send(0x4E, 12);
			printf ("127 -> ACK : %d\n",ack);
			Delay10KTCYx(255);
			Delay10KTCYx(128);

			RedLed=1;
			ack=I2C_Send(0x4E, -12);
			printf ("127 -> ACK : %d\n",ack);
			Delay10KTCYx(255);
			Delay10KTCYx(128);
			

			RedLed=0;
			ack=I2C_Send(0xBE, 12);
			printf ("0xBE -> ACK : %d\n",ack);
			Delay10KTCYx(255);
			Delay10KTCYx(128);


			RedLed=0;
			ack=I2C_Send(0xBE, -12);
			printf ("0xBE -> ACK : %d\n",ack);
			Delay10KTCYx(255);
			Delay10KTCYx(128);


	}	
	
*/
}
	while (1)	
	{		
		
		x++;
//		if (x%32<16) LCD_BackLight (LCD_BL_ON);
//		else LCD_BackLight (LCD_BL_OFF);
		if (x%4==0) printf ("x=%d y=%d Bp=%d\n",Joy_X(),Joy_Y(),Joy_Sw()); 
/*		LCD_Clear();
		for (x=0;x<12;x++)
		{
			printf ("x=%x ",256);
			Delay10TCYx(30);	
		} */
		LED_ROUGE=!LED_ROUGE;
//		Delay10KTCYx(30);	
	}
}
